#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

typedef unsigned _int32 uint;

bool *AtkinA(uint mx) {
  uint i,n,nn,x,y,xx,r=(uint)sqrt((double)mx);
  bool *sv=(bool*)malloc(mx+1);
  sv[0]=sv[1]=false; sv[2]=sv[3]=true; // for 0,1,2,3
  for(i=4; i<=mx; i++) sv[i]=false;
  for(x=1; x<=r; x++) {
    xx=3*x*x;
    for(y=1; y<x; y++) if((n=xx-y*y)<=mx && (n%12==11)) sv[n]=!sv[n];
    if(xx<mx) for(y=1; y<=r; y++) if((n=xx+y*y)<=mx && (n%12==7)) sv[n]=!sv[n];
    xx+=x*x;
    if(xx<mx) for(y=1; y<=r; y++) if((n=xx+y*y)<=mx && (n%12==1||n%12==5)) sv[n]=!sv[n];
  }
  for(n=5; n<=r; ++n) if(sv[n]) for(nn=n*n,i=nn; i<=mx; i+=nn) sv[i]=false;
  return sv;
} // William Voirol, Switzerland


int main() {
  printf("AtkinA: (classique avec bool[])");
  for(uint m=10; m<=1000000000; m*=10) {
    uint i,n;
    clock_t t=clock();
    bool *sv=AtkinA(m);
    t=clock()-t;
    for(i=0,n=0; i<=m; i++) if(sv[i]) ++n; // nombre de nombres premiers
    free(sv);
    printf("\nm=%u, n=%u, t=%u ms",m,n,1000*t/CLOCKS_PER_SEC);
  }
  getchar();
}