#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

typedef unsigned _int32 uint;
#define FlipBit(i) sv[i>>5]^=(1<<(i&31))
#define SetFalse(i) sv[i>>5]&=~(1<<(i&31))

uint *AtkinB(uint mx) { // Atkin
  uint i,k=1+mx/32,n,nn,x,y,xx,r=(uint)sqrt((double)mx);
  uint *sv=(uint*)malloc(k*sizeof(uint)); // (mx+1) bits
  sv[0]=12; // 0:false,1:false,2:true,3:true,4:false,...,31:false
  for(i=1; i<k; i++) sv[i]=0; // >31: false
  for(x=1; x<=r; x++) {
    xx=3*x*x;
    for(y=1; y<x; y++) if((n=xx-y*y)<=mx && (n%12==11)) FlipBit(n);
    if(xx<mx)
    for(y=1; y<=r; y++) if((n=xx+y*y)<=mx && (n%12==7)) FlipBit(n);
    xx+=x*x;
    if(xx<mx)
    for(y=1; y<=r; y++) if((n=xx+y*y)<=mx && (n%12==1||n%12==5)) FlipBit(n);
  }
  for(n=5; n<=r; ++n)
    if(sv[n>>5]&(1<<(n&31))) for(nn=n*n,i=nn; i<=mx; i+=nn) SetFalse(i);
  return sv;
} // William Voirol, Switzerland

int main() {
  printf("AtkinB: (classique avec bit[]/32)");
  for(uint m=10; m<=1000000000; m*=10) {
    uint i,n;
    clock_t t=clock();
    uint *sv=AtkinB(m);
    t=clock()-t;
    for(i=0,n=0; i<=m; i++)
    if(sv[i>>5]&(1<<(i&31))) ++n; // nombre de nombres premiers
    printf("\nm=%u, n=%u, t=%u ms",m,n,1000*t/CLOCKS_PER_SEC);
    free(sv);
  }
  getchar();
}