#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

typedef unsigned _int32 uint;

#define FlipBit(i) sv[i>>5]^=(1<<(i&31))
#define SetFalse(i) sv[i>>5]&=~(1<<(i&31))

uint *AtkinD(uint mx) {
  int e;
  uint a,d,g,n,k=1+mx/32,r=(uint)sqrt((double)mx);
  uint *sv=(uint*)malloc(k*sizeof(uint)); // (mx+1) bits
  sv[0]=12; // 0:false,1:false,2:true,3:true,4:false,...,31:false
  for(n=1; n<k; ++n) sv[n]=0; // initialize sieve
  for(a=11,d=12,g=24; a<=mx; a+=12,d+=12,g+=36) { // Boucle A
    for(n=a,e=g+24; (e>=48)&&(n<=mx); n+=(e-=72)) FlipBit(n);
    a+=d;
    for(n=a-12,e=g; (e>=48)&&(n<=mx); n+=(e-=72)) FlipBit(n);
    for(n=a,e=g+36; (e>=48)&&(n<=mx); n+=(e-=72)) FlipBit(n);
    a+=2*d;
    for(n=a-24,e=g-12;(e>=48)&&(n<=mx); n+=(e-=72)) FlipBit(n);
    for(n=a,e=g+24; (e>=48)&&(n<=mx); n+=(e-=72)) FlipBit(n);
    for(n=a+d-12,e=g; (e>=48)&&(n<=mx); n+=(e-=72)) FlipBit(n);
  }
  for(d=0,a=7; a<=mx; a+=(d+=24)) { // Boucle B
    for(n=a,e=-12; n<=mx; n+=(e+=72)) FlipBit(n);
    for(n=a+12,e=12; n<=mx; n+=(e+=72)) FlipBit(n);
  }
  for(d=4,a=5; a<=mx; a+=(d+=8)) { // Boucle C
    for(n=a,e=0; n<=mx; n+=(e+=8)) FlipBit(n);
    a+=(d+=8);
    for(n=a,e=0; n<=mx; n+=(e+=8)) FlipBit(n);
    a+=(d+=8);
    for(n=a,e=-24; n<=mx; n+=(e+=72)) FlipBit(n);
    for(n=a+24,e=24; n<=mx; n+=(e+=72)) FlipBit(n);
  }
  for(n=5; n<=r; ++n)
    if(sv[n>>5]&(1<<(n&31))) for(uint nn=n*n,i=nn; i<=mx; i+=nn) SetFalse(i);
  return sv;
} // William Voirol, Switzerland

int main() {
  printf("AtkinD: (bizarre avec bit[]/32)");
  for(uint m=100,n=0; m<=1000000000; m*=10,n=0) {
    clock_t t=clock();
    uint *sv=AtkinD(m);
    t=clock()-t;
    for(uint i=0; i<=m; i++)
    if(sv[i>>5]&(1<<(i&31))) ++n; // nombre de nombres premiers
    printf("\nm=%u, n=%u, t=%u ms",m,n,1000*t/CLOCKS_PER_SEC);
    free(sv);
  }
  getchar();
}